# kdecore Library API Documentation

Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# KCompletionBase Class Reference

An abstract base class for adding a completion feature into widgets. An abstract class for adding text completion support to widgets. More...

`#include <kcompletion.h>`

Inheritance diagram for KCompletionBase:

[legend]
Collaboration diagram for KCompletionBase:

[legend]
List of all members.

## Public Types

typedef QMap< KeyBindingType, KShortcut > | KeyBindingMap
enum | KeyBindingType { TextCompletion, PrevCompletionMatch, NextCompletionMatch, SubstringCompletion }
| Constants that represent the items whose short-cut key-binding is programmable. More...

## Public Member Functions

| KCompletionBase ()
| Default constructor.
virtual | ~KCompletionBase ()
| Destructor.
KCompletion * | completionObject (bool hsig=true)
| Returns a pointer to the current completion object.
virtual void | setCompletionObject (KCompletion *, bool hsig=true)
| Sets up the completion object to be used.
virtual void | setHandleSignals (bool)
| Enables this object to handle completion and rotation events internally.
bool | isCompletionObjectAutoDeleted () const
| Returns true if the completion object is deleted upon this widget's destruction.
void | setAutoDeleteCompletionObject (bool autoDelete)
| Sets the completion object when this widget's destructor is called.
void | setEnableSignals (bool enable)
| Sets the widget's ability to emit text completion and rotation signals.
bool | handleSignals () const
| Returns true if the object handles the signals.
bool | emitSignals () const
| Returns true if the object emits the signals.
virtual void | setCompletionMode (KGlobalSettings::Completion mode)
| Sets the type of completion to be used.
KGlobalSettings::Completion | completionMode () const
| Returns the current completion mode.
bool | setKeyBinding (KeyBindingType, const KShortcut &cut)
| Sets the key-binding to be used for manual text completion, text rotation in a history list as well as a completion list.
const KShortcut & | getKeyBinding (KeyBindingType item) const
| Returns the key-binding used for the specified item.
void | useGlobalKeyBindings ()
| Sets this object to use global values for key-bindings.
virtual void | setCompletedText (const QString &text)=0
| A pure virtual function that must be implemented by all inheriting classes.
virtual void | setCompletedItems (const QStringList &items)=0
| A pure virtual function that must be implemented by all inheriting classes.
KCompletion * | compObj () const
| Returns a pointer to the completion object.

## Protected Member Functions

KeyBindingMap | getKeyBindings () const
| Returns a key-binding map.
void | setDelegate (KCompletionBase *delegate)
| Sets or removes the delegation object.
KCompletionBase * | delegate () const
| Returns the delegation object.
virtual void | virtual_hook (int id, void *data)

## Detailed Description

An abstract base class for adding a completion feature into widgets. An abstract class for adding text completion support to widgets.

This is a convenience class that provides the basic functions needed to add text completion support into widgets. All that is required is an implementation for the pure virtual function setCompletedText. Refer to KLineEdit or KComboBox to see how easily such support can be added using this as a base class.

Author:
  Dawit Alemayehu <adawit@kde.org>

Definition at line 655 of file kcompletion.h.

## Member Enumeration Documentation

enum KCompletionBase::KeyBindingType

Constants that represent the items whose short-cut key-binding is programmable.

The default key-bindings for these items are defined in KStdAccel.

Enumeration values:

  TextCompletion | Text completion (by default Ctrl-E).
  PrevCompletionMatch | Switch to previous completion (by default Ctrl-Up).
  NextCompletionMatch | Switch to next completion (by default Ctrl-Down).
  SubstringCompletion | Substring completion (by default Ctrl-T).

Definition at line 665 of file kcompletion.h.

## Constructor & Destructor Documentation

KCompletionBase::KCompletionBase | ( |  | ) |

| Default constructor. Definition at line 25 of file kcompletionbase.cpp. References KGlobalSettings::completionMode(), and useGlobalKeyBindings().

KCompletionBase::~KCompletionBase | ( |  | ) | `[virtual]`

| Destructor. Definition at line 41 of file kcompletionbase.cpp.

## Member Function Documentation

KCompletion * KCompletionBase::completionObject | ( | bool | hsig = true | ) |

Returns a pointer to the current completion object.

If the object does not exist, it is automatically created. Note that the completion object created here is used by default to handle the signals internally. It is also deleted when this object's destructor is invoked. If you do not want these default settings, use setAutoDeleteCompletionObject and setHandleSignals to change the behavior. Alternatively, you can set the boolean parameter to false to disable the automatic handling of the signals by this object. Note that the boolean argument will be ignored if there already exists a completion object since no new object needs to be created. You need to use either setHandleSignals or setCompletionObject for such cases depending on your requirement.

Parameters:

  hsig | if true, handles signals internally.

Returns:
  a pointer the completion object.

Definition at line 62 of file kcompletionbase.cpp.

References setCompletionObject().

void KCompletionBase::setCompletionObject | ( | KCompletion * | ,
|  | bool | hsig = true
| ) | `[virtual]`

Sets up the completion object to be used.

This method assigns the completion object and sets it up to automatically handle the completion and rotation signals internally. You should use this function if you want to share one completion object among you widgets or need to use a customized completion object.

The object assigned through this method is not deleted when this object's destructor is invoked unless you explicitly call setAutoDeleteCompletionObject after calling this method. Also if you do not want the signals to be handled by an internal implementation, be sure to set the bool argument to false.

This method is also called when a completion-object is created automatically, when completionObject() is called the first time.

Parameters:

  compObj | a KCompletion() or a derived child object.
  hsig | if true, handles signals internally.

Reimplemented in KLineEdit.

Definition at line 75 of file kcompletionbase.cpp.

References QGuardedPtr< KCompletion >::isNull().

Referenced by completionObject().

void KCompletionBase::setHandleSignals | ( | bool |  | ) | `[virtual]`

Enables this object to handle completion and rotation events internally.

This function simply assigns a boolean value that indicates whether it should handle rotation and completion events or not. Note that this does not stop the object from emitting signals when these events occur.

Parameters:

  handle | if true, handle completion & rotation internally.

Definition at line 93 of file kcompletionbase.cpp.

bool KCompletionBase::isCompletionObjectAutoDeleted | ( |  | ) | const`[inline]`

Returns true if the completion object is deleted upon this widget's destruction.

See setCompletionObject() and enableCompletion() for details.

Returns:
  true if the completion object will be deleted automatically

Definition at line 769 of file kcompletion.h.

void KCompletionBase::setAutoDeleteCompletionObject | ( | bool | autoDelete | ) | `[inline]`

Sets the completion object when this widget's destructor is called.

If the argument is set to true, the completion object is deleted when this widget's destructor is called.

Parameters:

  autoDelete | if true, delete completion object on destruction.

Definition at line 782 of file kcompletion.h.

void KCompletionBase::setEnableSignals | ( | bool | enable | ) | `[inline]`

Sets the widget's ability to emit text completion and rotation signals.

Invoking this function with `enable` set to `false` will cause the completion & rotation signals not to be emitted. However, unlike setting the completion object to `NULL` using setCompletionObject, disabling the emition of the signals through this method does not affect the current completion object.

There is no need to invoke this function by default. When a completion object is created through completionObject or setCompletionObject, these signals are set to emit automatically. Also note that disabling this signals will not necessarily interfere with the objects ability to handle these events internally. See setHandleSignals.

Parameters:

  enable | if false, disables the emition of completion & rotation signals.

Definition at line 809 of file kcompletion.h.

bool KCompletionBase::handleSignals | ( |  | ) | const`[inline]`

Returns true if the object handles the signals.

Returns:
  true if this signals are handled internally.

Definition at line 821 of file kcompletion.h.

bool KCompletionBase::emitSignals | ( |  | ) | const`[inline]`

Returns true if the object emits the signals.

Returns:
  true if signals are emitted

Definition at line 828 of file kcompletion.h.

void KCompletionBase::setCompletionMode | ( | KGlobalSettings::Completion | mode | ) | `[virtual]`

Sets the type of completion to be used.

The completion modes supported are those defined in KGlobalSettings(). See below.

Parameters:

  mode

  Completion type:
  - CompletionNone: Disables completion feature.
  - CompletionAuto: Attempts to find a match & fills-in the remaining text.
  - CompletionMan: Acts the same as the above except the action has to be manually triggered through pre-defined completion key.
  - CompletionShell: Mimics the completion feature found in typical *nix shell environments.
  - CompletionPopup: Shows all available completions at once, in a listbox popping up.

Reimplemented in KLineEdit.

Definition at line 101 of file kcompletionbase.cpp.

References KGlobalSettings::CompletionNone.

KGlobalSettings::Completion KCompletionBase::completionMode | ( |  | ) | const`[inline]`

Returns the current completion mode.

The return values are of type KGlobalSettings::Completion. See setCompletionMode() for details.

Returns:
  the completion mode.

Definition at line 860 of file kcompletion.h.

References KGlobalSettings::Completion.

bool KCompletionBase::setKeyBinding | ( | KeyBindingType | ,
|  | const KShortcut & | cut
| ) |

Sets the key-binding to be used for manual text completion, text rotation in a history list as well as a completion list.

When the keys set by this function are pressed, a signal defined by the inheriting widget will be activated. If the default value or 0 is specified by the second parameter, then the key-binding as defined in the global setting should be used. This method returns false value for `key` is negative or the supplied key-binding conflicts with the ones set for one of the other features.

NOTE: To use a modifier key (Shift, Ctrl, Alt) as part of the key-binding simply simply `sum` up the values of the modifier and the actual key. For example, to use CTRL+E as a key binding for one of the items, you would simply supply `"Qt::CtrlButton + Qt::Key_E"` as the second argument to this function.

Parameters:

  item

  the feature whose key-binding needs to be set:
  - TextCompletion the manual completion key-binding.
  - PrevCompletionMatch the previous match key for multiple completion.
  - NextCompletionMatch the next match key for for multiple completion.
  - SubstringCompletion the key for substring completion

  key | key-binding used to rotate down in a list.

Returns:
  true if key-binding can successfully be set.

See also:
  getKeyBinding

Definition at line 115 of file kcompletionbase.cpp.

References QMap::begin(), KStdAction::cut(), QMap::end(), and QMap::replace().

const KShortcut& KCompletionBase::getKeyBinding | ( | KeyBindingType | item | ) | const`[inline]`

Returns the key-binding used for the specified item.

This methods returns the key-binding used to activate the feature feature given by `item`. If the binding contains modifier key(s), the SUM of the modifier key and the actual key code are returned.

Parameters:

  item | the item to check

Returns:
  the key-binding used for the feature given by `item`.

See also:
  setKeyBinding

Definition at line 908 of file kcompletion.h.

void KCompletionBase::useGlobalKeyBindings | ( |  | ) |

Sets this object to use global values for key-bindings.

This method changes the values of the key bindings for rotation and completion features to the default values provided in KGlobalSettings.

NOTE: By default inheriting widgets should uses the global key-bindings so that there will be no need to call this method.

Definition at line 130 of file kcompletionbase.cpp.

References QMap::clear(), QMap::insert(), NextCompletionMatch, PrevCompletionMatch, SubstringCompletion, and TextCompletion.

Referenced by KCompletionBase().

virtual void KCompletionBase::setCompletedText | ( | const QString & | text | ) | `[pure virtual]`

A pure virtual function that must be implemented by all inheriting classes.

This function is intended to allow external completion implementations to set completed text appropriately. It is mostly relevant when the completion mode is set to CompletionAuto and CompletionManual modes. See KCompletionBase::setCompletedText. Does nothing in CompletionPopup mode, as all available matches will be shown in the popup.

Parameters:

  text | the completed text to be set in the widget.

Implemented in KComboBox, and KLineEdit.

virtual void KCompletionBase::setCompletedItems | ( | const QStringList & | items | ) | `[pure virtual]`

A pure virtual function that must be implemented by all inheriting classes.

Parameters:

  items | the list of completed items

Implemented in KComboBox, and KLineEdit.

KCompletion* KCompletionBase::compObj | ( |  | ) | const`[inline]`

Returns a pointer to the completion object.

This method is only different from completionObject() in that it does not create a new KCompletion object even if the internal pointer is `NULL`. Use this method to get the pointer to a completion object when inheriting so that you won't inadvertently create it!!

Returns:
  the completion object or NULL if one does not exist.

Definition at line 959 of file kcompletion.h.

KeyBindingMap KCompletionBase::getKeyBindings | ( |  | ) | const`[inline, protected]`

Returns a key-binding map.

This method is the same as getKeyBinding() except it returns the whole keymap containing the key-bindings.

Returns:
  the key-binding used for the feature given by `item`.

Definition at line 970 of file kcompletion.h.

void KCompletionBase::setDelegate | ( | KCompletionBase * | delegate | ) | `[protected]`

Sets or removes the delegation object.

If a delegation object is set, all function calls will be forwarded to the delegation object.

Parameters:

  delegate | the delegation object, or 0 to remove it

Definition at line 49 of file kcompletionbase.cpp.

References m_bAutoDelCompObj, m_bEmitSignals, m_bHandleSignals, m_iCompletionMode, and m_keyMap.

KCompletionBase* KCompletionBase::delegate | ( |  | ) | const`[inline, protected]`

Returns the delegation object.

Returns:
  the delegation object, or 0 if there is none

See also:
  setDelegate()

Definition at line 984 of file kcompletion.h.

The documentation for this class was generated from the following files:

- kcompletion.h
- kcompletion.cpp
- kcompletionbase.cpp

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 12:47:20 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001